Package ec.breed

# Class BufferedBreedingPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.breed.BufferedBreedingPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class BufferedBreedingPipeline extends BreedingPipeline
If empty, a BufferedBreedingPipeline makes a request of exactly num-inds individuals from a single child source; it then uses these individuals to fill requests (returning min each time), until the buffer is emptied, at which time it grabs exactly num-inds more individuals, and so on.

What is this useful for? Well, let's say for example that you want to cross over two individuals, then cross them over again. You'd like to hook up two CrossoverPipelines in series. Unfortunately, CrossoverPipeline takes two sources; even if you set them to the same source, it requests one individual from the first source and then one from the second, where what you really want is for it to request two individuals from a single source (the other CrossoverPipeline).

The solution to this is to hook a CrossoverPipeline as the source to a BufferedBreedingPipeline of buffer-size 2 (or some multiple of 2 actually). Then the BufferedBreedingPipeline is set as both sources to another CrossoverPipeline.

Typical Number of Individuals Produced Per `produce(...)` call
1

Number of Sources
1

Parameters

base.`num-inds` int >= 1 | (the buffer size)

Default Base
breed.buffered

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `ArrayList<Individual>`
  `buffer`
  `int`
  `bufSize`
  `static final int`
  `INDS_PRODUCED`
  `static final int`
  `NUM_SOURCES`
  `static final String`
  `P_BUFFERED`
  `static final String`
  `P_BUFSIZE`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BufferedBreedingPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `void`
  `prepareToProduce(EvolutionState state, int subpopulation, int thread)`
  Called before produce(...), usually once a generation, or maybe only once if you're doing steady-state evolution, to let the breeding source "warm up" prior to producing.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `int`
  `typicalIndsProduced()`
  Returns the "typical" number of individuals produced -- by default this is the minimum typical number of individuals produced by any children sources of the pipeline.

  ### Methods inherited from class ec.BreedingPipeline

  `clone, fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, produces, sourcesAreProperForm`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_BUFSIZE

    public static final String P_BUFSIZE
    See Also:
      - Constant Field Values

  - ### P_BUFFERED

    public static final String P_BUFFERED
    See Also:
      - Constant Field Values

  - ### INDS_PRODUCED

    public static final int INDS_PRODUCED
    See Also:
      - Constant Field Values

  - ### NUM_SOURCES

    public static final int NUM_SOURCES
    See Also:
      - Constant Field Values

  - ### buffer

    public ArrayList<Individual> buffer

  - ### bufSize

    public int bufSize

- ## Constructor Details

  - ### BufferedBreedingPipeline

    public BufferedBreedingPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### typicalIndsProduced

    public int typicalIndsProduced()
    Description copied from class: `BreedingPipeline`
    Returns the "typical" number of individuals produced -- by default this is the minimum typical number of individuals produced by any children sources of the pipeline. If you'd prefer something different, override this method.
    Overrides:
      `typicalIndsProduced` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState state, int subpopulation, int thread)
    Description copied from class: `BreedingSource`
    Called before produce(...), usually once a generation, or maybe only once if you're doing steady-state evolution, to let the breeding source "warm up" prior to producing. Individuals should be produced from old individuals in positions [start...start+length] in the subpopulation only. May be called again to reset the BreedingSource for a whole 'nuther subpopulation.
    Overrides:
      `prepareToProduce` in class `BreedingPipeline`

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`